import 'dart:math';

// TODO: Is it better to wrap this in a class?  Maybe instantiate it with window size, average type,
//  and other parameters?  Or is that overkill?  Remember, KISS.

num mean(List<num> data) {
  return data.fold(
        0,
        (num a, num b) {
          return (a + b);
        },
      ) /
      data.length;
}

num weightedMean(List<num> data) {
  num sum = 0;
  for (var i = 0; i < data.length; i++) {
    sum += data[i] * (i + 1);
  }
  return sum / (data.length * (data.length + 1) / 2);
}

Iterable<List<num>> window(List<num> data, int size, {bool includePartial = false}) sync* {
  var start = 0;
  var end = 0;
  if (includePartial) {
    end = 1;
    start = end - size;
  } else {
    start = 0;
    end = size;
  }
  while (end <= data.length) {
    yield data.sublist(max(start, 0), end);
    start++;
    end++;
  }
  return;
}

// TODO: Use a single function, with averaging function as a parameter
// TODO: Support List<object> with a function object => num; can we use an identity function as
//  default?
List<num> movingAverage(List<num> data, int size, {bool includePartial = false}) {
  return window(data, size, includePartial: includePartial).map((values) {
    return mean(values);
  }).toList();
}

List<num> weightedMovingAverage(List<num> data, int size, {bool includePartial = false}) {
  return window(data, size, includePartial: includePartial).map((values) {
    return weightedMean(values);
  }).toList();
}
